<template>
  <v-card class="d-flex flex-column flex-grow-1">
    <!-- loading spinner -->
    <div v-if="loading" class="d-flex flex-grow-1 align-center justify-center">
      <v-progress-circular indeterminate color="primary"></v-progress-circular>
    </div>

    <!-- information -->
    <div v-else >
      <v-card-title>
        <h2>{{ label }}</h2>

        <div class="my-2">
          <v-select
            v-model="scope"
            solo
            dense
            hide-details
            :items="
              intervals.map(({ text, value }) => ({
                text: text,
                value: value,
              }))
            "
            @change="Counters(scope)"
          ></v-select>
        </div>
      </v-card-title>

      <div class="chart-wrap">
        <apexchart
          type="donut"
          width="85%"
          :options="chartOptions"
          :series="series"
        ></apexchart>
      </div>
    </div>
  </v-card>
</template>

<script>
import VueApexCharts from "vue-apexcharts";

import { mapActions, mapGetters } from "vuex";
export default {
  props: {
    label: {
      type: String,
      default: "",
    },
    color: {
      type: String,
      default: "#333333",
    },
    value: {
      type: Number,
      default: 0,
    },
    percentage: {
      type: Number,
      default: 0,
    },
    percentageLabel: {
      type: String,
      default: "vs. last week",
    },
    options: {
      type: Object,
      default: () => ({}),
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      series: [

      ],
      scope: "7days",
      intervals: [
        {
          text: this.$i18n.t("common.today"),
          value: "today",
        },
        {
          text: this.$i18n.t("common.yesterday"),
          value: "yesterday",
        },
        {
          text: this.$i18n.t("common.thisWeek"),
          value: "7days",
        },
        {
          text: this.$i18n.t("common.thisMonth"),
          value: "month",
        },
        {
          text: this.$i18n.t("common.thisYear"),
          value: "year",
        },
      ],
    };
  },
  methods: {
    ...mapActions("counters", ["fetchCounters"]),
    Counters(scope) {
      this.fetchCounters(scope).then(() => {
      this.series = [this.getCountersList.scopedTotal , this.getCountersList.total];
    });
    this.value = this.getCountersList.total;
    },
  },
  mounted() {
    this.fetchCounters("7days").then(() => {
      this.series = [this.getCountersList.scopedTotal , this.getCountersList.total];
      this.value = this.getCountersList.total;
    });
  },
  computed: {
    ...mapGetters("counters", ["getCountersList"]),
    chartOptions() {
      return {
        chart: {
          type: "donut",
          animations: {
            speed: 400,
          },
          background: "transparent",
        },
        stroke: {
          show: true,
          colors: [this.$vuetify.theme.isDark ? "#333" : "#fff"],
          width: 1,
          dashArray: 0,
        },
        plotOptions: {
          pie: {
            expandOnClick: false,
            donut: {
              size: "74%",
            },
          },
        },
        theme: {
          mode: this.$vuetify.theme.isDark ? "dark" : "light",
        },
        labels: [
          this.$i18n.t("common.newProviders"),
          this.$i18n.t("common.totalProviders"),
        ],
        dataLabels: {
          enabled: false,
        },
        colors: ["#bf87a0", "#E07979"],
        fill: {
          colors: ["#bf87a0", "#E07979"],
        },
        legend: {
          offsetY: 40,
          fontSize: "13px",
          fontFamily: "Quicksand",
          fontWeight: 700,
        },
        responsive: [
          {
            breakpoint: 480,
            options: {
              chart: {
                width: 200,
              },
              legend: {
                offsetY: 0,
                position: "bottom",
              },
            },
          },
        ],
        value: '',
        ...this.options,
      };
    },
  },
};
</script>

<style lang="scss" scoped>
.chart-wrap {
  max-width: 560px;
  max-height: 280px;
}
</style>
